package com.chelvc.framework.database.support;

import com.baomidou.mybatisplus.core.injector.AbstractMethod;
import com.baomidou.mybatisplus.core.metadata.TableInfo;
import org.apache.ibatis.mapping.SqlSource;

/**
 * 数据查询方法抽象实现
 *
 * @author Woody
 * @date 2024/5/28
 */
public abstract class AbstractSelectMethod extends AbstractMethod {
    /**
     * 初始化SQL数据源
     *
     * @param model 数据模型对象
     * @param table 表信息
     * @return SQL数据源对象实例
     */
    protected SqlSource initializeSqlSource(Class<?> model, TableInfo table) {
        String script = String.format(
                "<script>%s SELECT <foreach collection=\"select.expressions.entrySet()\" index=\"alias\" " +
                        "item=\"expression\" separator=\",\">${expression} as ${alias}</foreach> " +
                        "FROM %s %s %s\n</script>",
                this.sqlFirst(), table.getTableName(), this.sqlWhereEntityWrapper(true, table), this.sqlComment()
        );
        return this.languageDriver.createSqlSource(this.configuration, script, model);
    }
}
